﻿/**

*/
module nemuxi.negui.draw.icon;

debug import std.stdio: wl = writefln, pl = printf;
debug(icon) void main() {}

import win32.windows;

//import nemuxi.base;
import nemuxi.negui.system.base;
import nemuxi.negui.draw.draw;
//public import nemuxi.negui.draw.bitmap;


///
class IconException: DrawException {
	mixin MixInNeGuiException;
}

enum {
	LR_SHARD = 0x8000,
}

/**
*/
class Icon: Draw {
	/**
	アイコンサイズ。
	*/
	enum TYPE {
		SMALL , /// 16*16アイコン。
		NORMAL, /// 32*32アイコン。
	}
	static int typeToSize(TYPE Type) {
		final switch(Type) {
			case TYPE.SMALL:  return 16;
			case TYPE.NORMAL: return 32;
		}
	}
	
	protected alias Handle hIcon;
	mixin KillResource!("アイコン", hIcon, DestroyIcon, 0);

	override this(HANDLE Handle, bool Suicide) {
		super(Handle, Suicide);
	}
	enum STOCK: ushort {
		APPLICATION = OIC_SAMPLE     ,
		ASTERISK    = OIC_INFORMATION       ,
		EXCLAMATION = OIC_WARNING       ,
		HAND        = OIC_HAND    ,
		QUESTION    = OIC_QUES    ,
		WINLOGO     = OIC_WINLOGO,
	}
	this(STOCK Stock, TYPE Type) {
		auto size=typeToSize(Type);
		auto hIcon=LoadImage(
			null,
			MAKEINTRESOURCE(Stock),
			IMAGE_ICON,
			size, size,
			LR_SHARD
		);
		if(!hIcon) {
			throw new IconException(Text("STOCK(%s)", Stock));
		}
		super(hIcon, false);
	}

	///
	const Icon dup() {
		assert(hIcon);
		return new Icon(DuplicateIcon(null, hIcon), true);
	}
}

